=== debian/changelog ===
hipblas (6.4.3-1~exp1) experimental; urgency=medium

  [ Christian Bayle ]
  * Set watch for 6.4.x
  * New upstream version 6.4.3
  * Rebase patch for new version
  * Add salsa-ci.yaml
  * Use rocm-docs-build
  * Bump standards version to 4.7.2
  * Generate libhipblas2.symbols
  * Add patches to fix tests/bench build
  * Fix mathjax privacy
  * Add override for licence file in libhipblas-doc

  [ Kentaro Hayashi ]
  * Use d/watch 5

 -- Christian Bayle <bayle@debian.org>  Fri, 03 Oct 2025 23:18:04 +0200

hipblas (6.1.5-1~exp1) experimental; urgency=medium

  * prepare for 6.1.5
  * New upstream version 6.1.5
  * Patch rebase

 -- Christian Bayle <bayle@debian.org>  Mon, 24 Mar 2025 14:48:25 +0100

hipblas (5.5.1-4) unstable; urgency=medium

  * d/p/0007-hipsolver-compatibility.patch: add guard for hipblasOperation_t, 
    which had been missed when backporting the patch from upstream.
  * Update metadata for forwarded patches:
    - d/p/0008-public-link-hip.patch
    - d/p/0009-remove-immintrin-header.patch

 -- Cordell Bloor <cgmb@slerp.xyz>  Sun, 14 Apr 2024 00:46:59 -0600

hipblas (5.5.1-3) unstable; urgency=medium

  * d/control: add rocm-device-libs-17 to Build-Depends to fix FTBFS

 -- Cordell Bloor <cgmb@slerp.xyz>  Fri, 22 Mar 2024 23:07:55 -0600

hipblas (5.5.1-2) unstable; urgency=medium

  [ Christian Kastner ]
  * Add debian/clean (Closes: #1045423)
  * autopkgtest: Export dmesg and other info as artifacts
  * Update Upstream URL

  [ Cordell Bloor ]
  * Add support for nocheck build profile
  * Use dh-sequence-sphinxdoc to build doc package
  * Move examples from dev package to doc package
  * Add d/gbp.conf to ensure use of pristine-tar
  * d/control: libhipblas-dev now recommends librocblas-dev and
    librocsolver-dev for their CMake targets
  * d/control: libhipblas-dev now suggests libhipblas-doc
  * d/control: remove hipcc from Build-Depends
  * d/control: add librocsolver-dev to Build-Depends to enable
    the getrf, getrs, getri, geqrf and gels interfaces
  * Add d/p/0007-hipsolver-compatibility.patch to backport compatibility with
    hipsolver 6.0.0 and newer
  * Add d/p/0010-drop-f16c-instructions.patch and
    d/p/0009-remove-immintrin-header.patch to fix FTBFS on arm64 and ppc64el
  * Add d/p/0008-public-link-hip.patch to include hip::host in the hipblas
    interface link libraries

 -- Cordell Bloor <cgmb@slerp.xyz>  Fri, 22 Mar 2024 13:45:40 -0600
