=== debian/control ===
Source: hipblas
Section: devel
Homepage: https://github.com/ROCm/hipBLAS
Priority: optional
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/rocm-team/hipblas.git
Vcs-Browser: https://salsa.debian.org/rocm-team/hipblas
Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
Uploaders: Maxime Chambonnet <maxzor@maxzor.eu>,
           Cordell Bloor <cgmb@slerp.xyz>,
           Christian Kastner <ckk@debian.org>,
           Christian Bayle <bayle@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 cmake (>=4.1.1+really4~),
 cmake-data (>=4.1.1+really4~),
 clang,
 hipcc,
 rocm-cmake (>=6.4.0~),
 gfortran,
 libamdhip64-dev,
 librocblas-dev (>=6.4.0~),
 librocsolver-dev,
 libhipblas-common-dev (>=6.4.0~),
 libclang-rt-17-dev,
 git,
 llvm-17-dev,
 libblas64-dev,
 liblapack64-dev,
 libopenblas64-pthread-dev,
 libgtest-dev <!nocheck>,
 rocm-device-libs-17,
Build-Depends-Indep: dh-sequence-sphinxdoc <!nodoc>,
 python3-rocm-docs (>= 1.20.0-1~) <!nodoc>,
 python3-doxysphinx <!nodoc>,
 doxygen <!nodoc>,
 python3-breathe <!nodoc>,
 python3-sphinx <!nodoc>,
 python3-sphinx-rtd-theme <!nodoc>,
 libjs-jquery <!nodoc>,
 libjs-mathjax <!nodoc>,
 libjs-sphinxdoc <!nodoc>,
 libjs-underscore <!nodoc>
Build-Conflicts: rocm-device-libs-20
Rules-Requires-Root: no

Package: libhipblas2
Section: libs
Architecture: amd64 arm64 ppc64el
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: portable interface for GPU BLAS - library
 hipBLAS is a wrapper library that provides a common interface to rocBLAS and
 cuBLAS. The hipBLAS library is designed to help applications using cuBLAS to
 port their code to the ROCm platform.
 .
 This package provides the AMD ROCm hipBLAS library.

Package: libhipblas-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el
Depends: libhipblas2 (= ${binary:Version}),${misc:Depends}, ${shlibs:Depends},
         libamdhip64-dev,
Recommends: librocblas-dev, librocsolver-dev
Suggests: libhipblas-doc
Description: portable interface for GPU BLAS - headers
 hipBLAS is a wrapper library that provides a common interface to rocBLAS and
 cuBLAS. The hipBLAS library is designed to help applications using cuBLAS to
 port their code to the ROCm platform.
 .
 This package provides the AMD ROCm hipBLAS development headers.

Package: libhipblas2-tests
Section: libdevel
Architecture: amd64 arm64 ppc64el
Build-Profiles: <!nocheck>
Depends: libhipblas2 (= ${binary:Version}),${misc:Depends}, ${shlibs:Depends},
Description: portable interface for GPU BLAS - tests
 hipBLAS is a wrapper library that provides a common interface to rocBLAS and
 cuBLAS. The hipBLAS library is designed to help applications using cuBLAS to
 port their code to the ROCm platform.
 .
 This package provides the AMD ROCm hipBLAS test binaries used for verifying
 that the library is functioning correctly.

Package: libhipblas-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends: ${misc:Depends},
         ${sphinxdoc:Depends},
         libjs-mathjax,
Replaces: libhipblas-dev (<< 5.5.1-2~)
Breaks: libhipblas-dev (<< 5.5.1-2~)
Description: portable interface for GPU BLAS - documentation
 hipBLAS is a wrapper library that provides a common interface to rocBLAS and
 cuBLAS. The hipBLAS library is designed to help applications using cuBLAS to
 port their code to the ROCm platform.
 .
 This package provides the AMD ROCm hipBLAS documentation.
