=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export VERBOSE=1
export HIP_PLATFORM=amd

CMAKE_FLAGS = \
	-DCMAKE_BUILD_TYPE=Release \
	-DROCM_SYMLINK_LIBS=OFF \
	-DBUILD_FILE_REORG_BACKWARD_COMPATIBILITY=OFF \
	-DHIPBLAS_FIND_PACKAGE_LAPACK_CONFIG=OFF \
	-DBUILD_WITH_SOLVER=ON \
	-DBUILD_CLIENTS_BENCHMARKS=ON \
	-DBUILD_CLIENTS_SAMPLES=OFF
	-DLINK_BLIS=OFF \
	-DHIP_PLATFORM=$(shell hipconfig --platform)

ifeq (,$(filter nocheck,$(DEB_BUILD_PROFILES)))
CMAKE_FLAGS += \
	-DBUILD_CLIENTS_TESTS=ON
endif

# From TheRock
# -DCMAKE_BUILD_TYPE=Release
#  -DHIP_PLATFORM=amd
#  -DBUILD_WITH_SOLVER=ON
#  -DBUILD_CLIENTS_TESTS=ON
#  -DBUILD_CLIENTS_BENCHMARKS=ON
#  -DBUILD_CLIENTS_SAMPLES=OFF
#  -DLINK_BLIS=OFF

%:
	dh $@ -Scmake

override_dh_auto_configure-arch:
	[ -L $(CURDIR)/clients/include/cblas.h ] || \
		ln -s /usr/include/$(DEB_HOST_MULTIARCH)/openblas64-pthread/cblas.h \
		$(CURDIR)/clients/include/cblas.h
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	set -e \
	; if [ -r /dev/kfd ] \
	; then obj-$(DEB_HOST_MULTIARCH)/clients/staging/hipblas-test --gtest_filter="-*known_bug*" \
	; else echo "W: /dev/kfd unreadable: no available AMD GPU." \
	;      echo "W: tests skipped." \
	; fi
endif

override_dh_auto_configure-indep:
	:

execute_after_dh_auto_build-indep: export http_proxy=127.0.0.1:9
execute_after_dh_auto_build-indep: export https_proxy=127.0.0.1:9
execute_after_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	rocm-docs-build
	rm -rf build/html/_static/fonts
	rm -rf build/html/_static/vendor
	find build/html -name hipblas-api-functions.html \
		-exec perl -ni -e 'print unless /cdn\.jsdelivr\.net/' {} \;
endif

override_dh_auto_test-indep:
	:

override_dh_auto_install-indep:
	:

LIB=libhipblas2
LIBV=6.4.3
REV=1~exp1
gensymbols: 
	dpkg-deb -x ../$(LIB)_$(LIBV)-$(REV)_amd64.deb /tmp/$(LIB)
	dpkg-gensymbols -v$(LIBV) -p$(LIB) -P/tmp/$(LIB) -Odebian/$(LIB).symbols
