=== debian/tests/control ===
Test-Command: /bin/sh debian/tests/upstream-binaries libhipblas2-tests
Depends: libhipblas2-tests
Restrictions: skippable, allow-stderr, needs-sudo
Architecture: amd64
